unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.StdCtrls,
  FMX.Controls.Presentation;

type
  TForm2 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    Button1: TButton;
    procedure FormPaint(Sender: TObject; Canvas: TCanvas; const ARect: TRectF);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

{$R *.fmx}
{$R *.LgXhdpiPh.fmx ANDROID}

uses Math, System.Diagnostics, System.TimeSpan;

var Stopwatch: TStopwatch;
    Elapsed: TTimeSpan;

procedure TForm2.Button1Click(Sender: TObject);
begin
  Self.Invalidate;
end;

procedure TForm2.FormPaint(Sender: TObject; Canvas: TCanvas;
  const ARect: TRectF);
var i, j, n, r: Integer;
    step: Double;
    path: FMX.Graphics.TPathData;
    points: array of TPointF;
    pos: TPointF;
begin
  Stopwatch:=TStopwatch.StartNew;

  n:=20;
  r:=10;
  SetLength(points,n);
  step:=DegToRad(360/n);
  for i:=0 to n-1 do
    points[i]:=PointF(r*Cos(i*step),r*Sin(i*step));

  pos:=PointF(r,r);
  for i:=1 to 1000 do
  begin
    path:=TPathData.Create;
    path.MoveTo(PointF(pos.X+points[0].X,pos.Y+points[0].Y));

    for j:=1 to n-1 do
      path.LineTo(PointF(pos.X+points[j].X,pos.Y+points[j].Y));

    path.ClosePath;

    Canvas.Fill.Color:=TAlphaColorF.Create(random*255,random*255,random*255).ToAlphaColor;
    Canvas.FillPath(path, 1);

    Canvas.Stroke.Color:=TAlphaColorRec.Black;
    Canvas.Stroke.Kind:=TBrushKind.Solid;
    Canvas.DrawPath(path,1);

    path.Free;

    if (pos.X+(r*3)<Self.Width) then
       pos.X:=pos.X+(r*2)
    else
    begin
       pos.X:=r;
       if (pos.Y+(r*3)<Self.Height) then
          pos.Y:=pos.Y+(r*2)
       else
         pos:=PointF(r,r);
    end;
  end;

  Elapsed:=Stopwatch.Elapsed;
  Label1.Text:='Drawn in ' + IntToStr(Round(Elapsed.TotalMilliseconds)) + 'ms';
end;

end.
